
/*
 * adc.S
 *
 *  Author: razvan
 */
 #include <avr/io.h>
 #include "defines.h"
 #include "adc_macro.S"

.global START_ADC
START_ADC:
    push TEMP_REGISTER_ONE
    push TEMP_REGISTER_TWO
    lds TEMP_REGISTER_ONE, (1 << ADLAR)
    or  TEMP_REGISTER_ONE, (1 << MUX3)
    sts ADMUX, TEMP_REGISTER_ONE
    ldi TEMP_REGISTER_ONE, (1 << ADEN) | (1 << ADPS2) // Enable ADC, scaling factor 16
    sts ADCSRA, TEMP_REGISTER_ONE
    // We started the ADC, do a dummy read
    READ_ADC TEMP_REGISTER_ONE, TEMP_REGISTER_ONE
    pop TEMP_REGISTER_TWO
    pop TEMP_REGISTER_ONE
    ret 
